var debug = false;
var shiftKeyPressed = false;
var beingDragged = false;
var resizeEntry = false;
var allowDeselect = true;
var colors = ['#1E90FF', '#FF1493', '#4B0082', '#32CD32', '#FF8C00', '#000000'];
var selectedColor;
var colorButtons = {};
var thicknessValue = 1;
var opacityValue = 0.4;
var draggableState = true
var overlays = [];
var entryType = [];
var selectedShapes = [];
var listenersArray = [];
var mapsArray = [];
var controlsId = null;
var drawingManager;
var selectedShape;
var map = null;
var dragS, dragN;
var dsNorth, dsSouth, dsEast, dsWest;
//var gaj, gal, maj, mal;
var counter = 0;
var branchNum = 1;
var mouseState = "up";
var thicknessRangeListener = thicknessValue;
var resizable = false;
var dontResize = false;

var mapEditorHistory = new MapEditorHistory();

var polyOptions = {
	fillColor: '#CA4A2F',
	strokeWeight: thicknessValue,
	fillOpacity: opacityValue,
	editable: true,
	draggable: draggableState,
	geodesic: false
};

function MapEditor() {
	this.shiftKeyPressed = false;
	this.beingDragged = false;
	this.resizeEntry = false;
	this.allowDeselect = true;
	this.colors = ['#1E90FF', '#FF1493', '#4B0082', '#32CD32', '#FF8C00', '#000000'];
	this.selectedColor;
	this.colorButtons = {};
	this.thicknessValue = 1;
	this.opacityValue = 0.4;
	this.draggableState = true
	this.overlays = [];
	this.entryType = [];
	this.selectedShapes = [];
	this.listenersArray = [];
	this.mapsArray = [];
	this.controlsId = null;
	this.drawingManager;
	this.selectedShape;
	this.map = null;
	this.dragS, dragN;
	this.dsNorth, dsSouth, dsEast, dsWest;
	// gaj, gal, maj, mal;
	this.counter = 0;
	this.branchNum = 1;
	this.mouseState = "up";
	this.thicknessRangeListener = thicknessValue;
	this.resizable = false;
	this.dontResize = false;
	
	this.mapEditorHistory = new MapEditorHistory();
	
	this.polyOptions = {
		fillColor: '#CA4A2F',
		strokeWeight: thicknessValue,
		fillOpacity: opacityValue,
		editable: true,
		draggable: this.draggableState,
		geodesic: false
};
}

//MapEditor.prototype.initMapEditorControls = function(id) {
//};

	
function initMapEditorControls(id) {
	console.log(id);
	//change draggable
	var draggableCB = document.querySelector("input[name=draggableCB]");	
	
	draggableCB.addEventListener('change', function () {
		if (this.checked) {
			draggableState = false;
			for (var i = 0; i < overlays.length; i++) {
				overlays[i].draggable = draggableState;
				polyOptions.draggable = draggableState;
			}
		} else {
			draggableState = true;
			for (var i = 0; i < overlays.length; i++) {
				overlays[i].draggable = draggableState;
				polyOptions.draggable = draggableState;
			}
		}
	});

	//Update thickness
	var thicknessSlider = document.getElementById("thicknessRange" +"-"+ id);
	var thicknessSliderOutput = document.getElementById("thicknessRangeVal" +"-"+ id);
	thicknessSliderOutput.innerHTML = thicknessSlider.value / 20;
	
	thicknessSlider.oninput = function () {
		shapeSpecsChangeMD();
		thicknessSliderOutput.innerHTML = this.value / 20;
		thicknessValue = this.value / 20;		
		polyOptions.strokeWeight = thicknessValue;
		setSelectedThickness(thicknessValue);

	}
	//Update opacity
	var opacitySlider = document.getElementById("colourOpacity" +"-"+ id);
	var opacitySliderOutput = document.getElementById("opacityRangeVal" +"-"+ id);
	opacitySliderOutput.innerHTML = Math.round(opacitySlider.value) /100;

	opacitySlider.oninput = function () {
		shapeSpecsChangeMD();
		opacitySliderOutput.innerHTML = "% " + this.value;
		opacityValue = this.value / 100;		
		polyOptions.fillOpacity = opacityValue;
		setSelectedOpacity(opacityValue);
	}

	document.getElementById("color-palette1" +"-"+ id).addEventListener("mousedown", shapeSpecsChangeMD);
	document.getElementById("thicknessRange" +"-"+ id).addEventListener("mouseup", shapeSpecsChangeMU);
	document.getElementById("colourOpacity"  +"-"+ id).addEventListener("mouseup", shapeSpecsChangeMU);
	document.onmousemove = mouseMove;
	document.onmousedown = mouseDown;
	document.onmouseup = mouseUp;
}


function settingThePath() {
	listenersArray = []
	counter = 0;
	branchNum = 1;

	for (var i = 0; i < selectedShapes.length * 2; i++) {
		for (var j = 1; j < 5; j++) {
			var path = "//*[@id='map']/div/div/div[1]/div[3]/div/div[3]/div[" + branchNum + "]/div[" + j + "]/div";
			listenersArray[counter] = getElementByXpath(path);
			if (listenersArray[counter] !== undefined && listenersArray[counter] !== null) {
				listenersArray[counter].addEventListener("mousemove", function () {
					resizable = true;
					shapeResize();
				});
				listenersArray[counter].addEventListener("mouseout", function () {
					if (mouseDown) {
						resizable = true;
						shapeResize();
					}
				});
			}
			counter++;
		}
		branchNum++;
	}
}



function shapeResize() {
	if (mouseState == "down") {
		if (selectedShapes.length > 0) {
			if (resizable) {
				if(dontResize == false){
					historyOverlayPush();
				}
				
			}
		}
	}
}

function shapeSpecsChangeMD() {

	if (selectedShapes.length > 0) {
		historyOverlayPush();
	}
}

function shapeSpecsChangeMU() {
	if (selectedShapes.length > 0) {
		presentOverlayPush();
	}
}

function makeColorButton(color) {
	var button = document.createElement('span');
	button.className = 'color-buttons1';
	button.style.backgroundColor = color;
	google.maps.event.addDomListener(button, 'click', function () {
		selectColor(color);
		setSelectedShapeColor(color);
		shapeSpecsChangeMU();
	});
	return button;
}
function buildColorPalette(id) {
	console.log("colour palette build");
	var colorPalette = document.getElementById("color-palette1" +"-"+ id);
	for (var i = 0; i < colors.length; ++i) {
		var currColor = colors[i];
		var colorButton = makeColorButton(currColor);
		colorPalette.appendChild(colorButton);
		colorButtons[currColor] = colorButton;
	}
	selectColor(colors[0]);
};
function selectColor(color) {
	selectedColor = color;
	for (var i = 0; i < colors.length; ++i) {
		var currColor = colors[i];
		colorButtons[currColor].style.border = currColor == color ? '2px solid #789' : '2px solid #fff';
	}

	// Retrieves the current options from the drawing manager and replaces the
	// stroke or fill color as appropriate.
	var polylineOptions = drawingManager.get('polylineOptions');
	polylineOptions.strokeColor = color;
	drawingManager.set('polylineOptions', polylineOptions);

	var rectangleOptions = drawingManager.get('rectangleOptions');
	rectangleOptions.fillColor = color;
	drawingManager.set('rectangleOptions', rectangleOptions);

	var circleOptions = drawingManager.get('circleOptions');
	circleOptions.fillColor = color;
	drawingManager.set('circleOptions', circleOptions);

	var polygonOptions = drawingManager.get('polygonOptions');
	polygonOptions.fillColor = color;
	drawingManager.set('polygonOptions', polygonOptions);
}

function initMapEditor(id) {
	var that = this;
	
	map = new google.maps.Map(document.getElementById("map-" + id), {
			center: {
				lat: -37.7891,
				lng: 175.3180
			},
			zoom: 14,
			mapId: id,
		});
	mapsArray.push(map);	
	console.log(map);	
	// Add a style-selector control to the map.
	var styleControl = document.getElementById('style-selector-control' +"-"+ id);
	map.controls[google.maps.ControlPosition.TOP_LEFT].push(styleControl);

	// Set the map's style to the initial value of the selector.
	var styleSelector = document.getElementById('style-selector' +"-"+ id);
	console.log(styleSelector);
	//map = google.maps.Map(document.getElementById('map' +"-"+ id));
	console.log(map);
	map.setOptions({
		styles: styles[styleSelector.value]
		
	});
	
	// Apply new JSON when the user selects a different style.
	styleSelector.addEventListener('change', function () {
		console.log(id);
		mapsArray.indexOf(map).setOptions({
			styles: styles[styleSelector.value]
		});
	});

	drawingManager = new google.maps.drawing.DrawingManager({
			drawingMode: google.maps.drawing.OverlayType.RECTANGLE,
			drawingControl: true,
			drawingControlOptions: {
				position: google.maps.ControlPosition.TOP_CENTER,
				drawingModes: ['marker', 'circle', 'polygon', 'polyline', 'rectangle']
			},
			markerOptions: {
				draggable: draggableState
			},
			circleOptions: polyOptions,
			polylineOptions: polyOptions,
			polygonOptions: polyOptions,
			rectangleOptions: polyOptions,
		});

	drawingManager.setMap(map);

	google.maps.event.addListener(drawingManager, "drawingmode_changed", function () {
		if(shiftKeyPressed != true && drawingManager.drawingMode !== null){
			deselectAll();
		}
		settingThePath();

	})

	// store reference to added overlay
	google.maps.event.addListener(drawingManager, 'overlaycomplete', function (e) {
		allowDeselect = true;
		historyOverlayPush();
		overlays.push(e.overlay); // store reference to added overlay
		var newShape = e.overlay;
		newShape.type = e.type;
		presentOverlayPush();

		if (e.type !== google.maps.drawing.OverlayType.MARKER) {
			addShapeListeners(newShape, e);
			setSelection(newShape, e);
		} else {

			addMarkerListeners(newShape, e);
			setSelection(newShape, e);
		}
	});

	//Clears selection if clicked on the map when shift is not presseed
	google.maps.event.addListener(map, 'click', function (e) {
		var c = document.body.childNodes;
		if (e.target && e.target.matches("a.classA")) {
			console.log("Anchor element clicked!");
		}
		if (shiftKeyPressed == false) {
			clearSelection();
			selectedShape = null;
		}
	});
	
	google.maps.event.addListener(map, 'mousedown', function (e) {
		dontResize = true;
	});	
	
	google.maps.event.addListener(map, 'mouseup', function (e) {
		dontResize = false;
	});	
	
	//Keyboard shortcuts
	document.addEventListener('keydown', function () {
		if (event.code == 'KeyY' && (event.ctrlKey || event.metaKey) || (event.code == 'KeyZ' && event.code == 'ShiftLeft' && (event.ctrlKey || event.metaKey))) {
			redo();
		}
		if (event.code == 'KeyZ' && (event.ctrlKey || event.metaKey)) {
			if (shiftKeyPressed == false) {
				undo();
				mapEditorHistory.undo(overlays); // ***** when we only have MapEditorHistory as a class
				//that.mapEditorHistory.undo(that.overlays); // ***** when we have both MapEditorHistory and MapEditor as classes
				
			}
		}
		if (event.code == 'KeyA' && (event.ctrlKey || event.metaKey)) {
			event.preventDefault();
			drawingManager.setDrawingMode(null);
			selectAll();
			
		}
		if (event.code == 'KeyD' && (event.ctrlKey || event.metaKey)) {
			event.preventDefault();
			deselectAll();
		}
		if (event.code == 'Digit0' || event.code == 'Numpad0' || event.code == 'Backquote') {

			drawingManager.setDrawingMode(null);
		} else if (event.code == 'Digit1') {
			drawingManager.setDrawingMode('marker');
		} else if (event.code == 'Digit2') {
			drawingManager.setDrawingMode('circle');
		} else if (event.code == 'Digit3') {
			drawingManager.setDrawingMode('polygon');
		} else if (event.code == 'Digit4') {
			drawingManager.setDrawingMode('polyline');
		} else if (event.code == 'Digit5') {
			drawingManager.setDrawingMode('rectangle');
		} else if (event.code == 'KeyQ') {
			printHistory();
		}
		//							console.log(event.code);
	});

	//Sets shift as pressed
	document.addEventListener('keydown', function () {
		if (event.code == 'ShiftLeft' || event.code == 'ShiftRight') {
			shiftKeyPressed = true;

		}

	});

	//Sets shift as unpressed
	document.addEventListener('keyup', function () {
		if (event.code == 'ShiftLeft' || event.code == 'ShiftRight') {
			shiftKeyPressed = false;
		}

	});

	buildColorPalette(id);
}

//Deletes a vertex if clicked on it
function vertexAndPolyDel(e, newShape) {
	var vertex = e.vertex;
	if (e.vertex !== undefined) {
		if (newShape.type === google.maps.drawing.OverlayType.POLYGON) {
			var path = newShape.getPaths().getAt(e.path);
			path.removeAt(e.vertex);
			if (path.length < 3) {
				newShape.setMap(null);
			}
		}
		if (newShape.type === google.maps.drawing.OverlayType.POLYLINE) {
			var path = newShape.getPath();
			path.removeAt(e.vertex);
			if (path.length < 2) {
				newShape.setMap(null);
			}
		}
	}
}

function addMarkerListeners(newShape, e) {
	//cLICK EVENT IF A MARKER IS CREATED
	google.maps.event.addListener(newShape, 'click', function (e) {
		setSelection(newShape, e);
	});

	google.maps.event.addListener(newShape, 'dragstart', function (e) {
		beingDragged = true;
		historyOverlayPush();

	});

	google.maps.event.addListener(newShape, 'dragend', function () {
		beingDragged = false;
		presentOverlayPush();
		allowDeselect = false;
	});
}

function addShapeListeners(newShape, e) {
	// Add an event listener that selects the newly-drawn shape when the user
	// mouses down on it.
	google.maps.event.addListener(newShape, 'click', function (e) {

		vertexAndPolyDel(e, newShape);

	});

	google.maps.event.addListener(newShape, 'dragstart', function (e) {
		allowDeselect = false;
		historyOverlayPush();
	});



	google.maps.event.addListener(newShape, 'dragend', function () {
		beingDragged = false;
		presentOverlayPush();
		settingThePath();
		
		allowDeselect = false;
		setSelection(newShape, e);
	});

	//Store information after the event ends
	google.maps.event.addListener(newShape, 'bounds_changed', function (e) {
		if (beingDragged == false) {
			presentOverlayPush();
		}
	});

	//Add an event listener to select a shape if the mouse hovers over it
	google.maps.event.addListener(newShape, 'mousedown', function (e) {
		if (e.target && e.target.matches("a.classA")) {
			console.log("Anchor element clicked!");
		}
		if (e.vertex !== undefined || e.edge !== undefined) {
			historyOverlayPush()
		}
		if (drawingManager.drawingMode == null) {
			setSelection(newShape, e);
		}
	});

	google.maps.event.addListener(newShape, 'mouseup', function (e) {
		if (e.vertex !== undefined || e.edge !== undefined) {
			presentOverlayPush()
		} else {
			//setSelection(newShape, e);
		}
		
	});
}
function clearSelection() {
	if (selectedShape) {
		if (selectedShape.type !== 'marker') {
			selectedShape.setEditable(false);
			if (shiftKeyPressed == false) {
				for (var i = 0; i < selectedShapes.length; i++) {
					selectedShapes[i].setEditable(false);
				}
				selectedShapes = [];
			}
		}
		selectedShape = null;
	}
}

//Set selection for the selected overlay
function setSelection(shape, e) {
	if (shape.type !== 'marker') {
		if (shiftKeyPressed == false) {
			if(e !== null) {
				if (e.vertex == undefined) {
					if (e.edge == undefined) {
						clearSelection();
						shape.setEditable(true);
					}
				}				
			}
		}
		if (selectedShapes.includes(shape)) {
			if(e !== null){
				if (e.vertex == undefined) {
					if (e.edge == undefined) {
						allowDeselect = true;
						removeFromSelectedShapes(shape);
					}
				}
			}
		} else {
			allowDeselect = false;
			shape.setEditable(true);
			selectedShapes.push(shape);
		}

		//Send the values to be updated
		var thi = shape.strokeWeight;
		var opa = shape.fillOpacity;
		var fCol = shape.fillColor;
		var sCol = shape.strokeColor;
		//updateMenuValues(thi, opa, fCol, sCol);

	} else if (shape.type == 'marker') {
		clearSelection();
	}
	selectedShape = shape;
	settingThePath();
}

function removeFromSelectedShapes(shape) {
	if (selectedShapes.includes(shape)) {
		if (allowDeselect) {
			const index = selectedShapes.indexOf(shape);
			selectedShapes.splice(index, 1);
			shape.setEditable(false);
		}
		allowDeselect = true;
	} 
}

//Set selected thickness
function setSelectedThickness(sWeight) {
	if (selectedShapes.length > 0) {
		//historyOverlayPush();
		for (var i = 0; i < selectedShapes.length; i++) {
			selectedShapes[i].set('strokeWeight', sWeight);
		}
	}
}

//Set selected opacity
function setSelectedOpacity(fOpacity) {

	if (selectedShapes.length > 0) {
		for (var i = 0; i < selectedShapes.length; i++) {
			selectedShapes[i].set('fillOpacity', fOpacity);
		}
	}
}

//set selected fill colour
function setSelectedShapeColor(color) {
	if (selectedShapes.length > 0) {
		for (var i = 0; i < selectedShapes.length; i++) {
			selectedShapes[i].set('fillColor', color);
			selectedShapes[i].set('strokeColor', color);
		}
	}
}
function getElementByXpath(path) {
	return document.evaluate(path, document, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null).singleNodeValue;
}

function updateMenuValues(thi, opa, fCol, sCol, id) {
	//Update thickness slider and value on the settings menu
	var thicknessSliderOutput = document.getElementById("thicknessRangeVal" +"-"+ id);
	thicknessSliderOutput.innerHTML = thi;
	document.getElementById("thicknessRange" +"-"+ id).value = thi * 20;

	//Update the opacity slider and value on the settings menu
	var opacitySliderOutput = document.getElementById("opacityRangeVal" +"-"+ id);
	opacitySliderOutput.innerHTML = "% " + opa * 100;
	document.getElementById("colourOpacity" +"-"+ id).value = opa * 100;

	if (drawingManager.drawingMode == null) {
		selectColor(fCol);
	}
}
function selectAll() {
	shiftKeyPressed = true;
	var e = new Object();
	e.vertex = undefined;
	selectedShapes = [];
	for (var i = 0; i < overlays.length; i++) {
		setSelection(overlays[i], e);
	}
	shiftKeyPressed = false;
}

function deselectAll() {
	for (var i = 0; i < selectedShapes.length; i++) {
		selectedShapes[i].setEditable(false);
	}
	selectedShapes = [];
}

function printHistory() {
	console.log("prev", prevOverlays);
	console.log("present ", presentOverlays);
	console.log("undone ", undoneOverlays);
	console.log(mouseState);
}

function mouseMove(ev) {

	//How can I know the state of mouse from here
	if (mouseState == 'down') {
		//console.log('mouse down state')
	}

	if (mouseState == 'up') {
		//console.log('mouse up state')
	}
}

function mouseDown(ev) {
	mouseState = "down";
	//    console.log('Down State you can now start dragging');
	//do not write any code here in this function
}

function mouseUp(ev) {
	mouseState = "up";
	//    console.log('up state you cannot drag now because you are not holding your mouse')
	//do not write any code here in this function
}

function deleteSelectedShape() {
	//console.log("this fires");
	historyOverlayPush();
	for (var i = 0; i < selectedShapes.length; i++) {
		selectedShapes[i].setMap(null);

		if (overlays.includes(selectedShapes[i])) {
			const index = overlays.indexOf(selectedShapes[i]);
			overlays.splice(index, 1);
			selectedShapes[i].setEditable(false);
		}
	}
	selectedShapes = [];
	//console.log("this fires");
	presentOverlayPush();
}

function deleteAllShape(nId) {
	console.log(nId);
	//console.log("this fires");
	historyOverlayPush();
	for (var i = 0; i < overlays.length; i++) {
		overlays[i].setMap(null);
	}
	overlays = [];
	//console.log("this fires");
	presentOverlayPush();
}